/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1822
        Driver Version    :  2.00
 
  IR Transmit Format : Start bit(1),Data bit(4),Stop bit(1)   600us/bit


*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

// Pin̒`t(DVR8835 - PIC)
#define AIN1 RA5
#define AIN2 RA4
#define BIN1 RA1
#define BIN2 RA0

// O[oϐ錾
unsigned int b1,b2,b3,b4;       // Mf[^(4rbg)ϐ
unsigned int TTL;               // Mf[^(4rbg)v

// vg^CsO錾
void Rev(void);                 // ޓ֐

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
   
    while (1)
    {
        // Add your application code
        
        TTL = b1 = b2 = b3 = b4 = 0;            // ϐNA        
        AIN1 = AIN2 = BIN1 = BIN2 = 0;          // [^hCoNA
        
    // X^[grbg`FbN    
        if (RA3 == 0)                   // MoȂ
            __delay_us(300);            // 300usɍă`FbN 
        else                            // oȂM҂
            break;

    // X^[grbgă`FbN
        if (RA3 == 0)                   // MoȂ
            __delay_us(600);            // f[^rbg`FbN 
        else                            // oȂM҂
            break;

    // f[^rbgb1`FbN
        if (RA3 == 0)                   // MoȂ
            b1 = 8;                     // b1=8 
        else                            // oȂ
            b1 = 0;                     // b1=0

        __delay_us(600);
                
    // f[^rbgb2`FbN
        if (RA3 == 0)                   // MoȂ
            b2 = 4;                     // b2=4 
        else                            // oȂ
            b2 = 0;                     // b2=0

        __delay_us(600);
                
    // f[^rbgb3`FbN
        if (RA3 == 0)                   // MoȂ
            b3 = 2;                     // b3=2 
        else                            // oȂ
            b3 = 0;                     // b3=0

        __delay_us(600);

    // f[^rbgb4`FbN
        if (RA3 == 0)                   // MoȂ
            b4 = 1;                     // b4=1 
        else                            // oȂ
            b4 = 0;                     // b4=0

        __delay_us(600);
        
    // Xgbvrbg`FbN    
        if (RA3 == 0)                   // MoȂ
            TTL = b1 + b2 + b3 + b4;    // f[^rbgv 
        else                            // oȂMMj
            break;        

    // OQ`FbN    
        if (RA2 == 0)                   // QoȂ
            Rev();                      // 

        
    // s       
        switch(TTL) {                   // TTLŕ
            case 0:
                AIN1 = AIN2 = BIN1 = BIN2 = 0;          // ~(f[^p^[:0000)            
                __delay_ms(100);                
                break;                

            case 1:
                AIN1 = BIN1 = 1;          // Oi(f[^p^[:0001)            
                __delay_ms(100);                
                break;

            case 2:
                AIN2 = BIN2 = 1;          // (f[^p^[:0010)            
                __delay_ms(100);                
                break;

            case 4:
                AIN1 = 1;               // E(f[^p^[:0100)            
                __delay_ms(100);                
                break;
                
            case 8:
                BIN1 = 1;               // (f[^p^[:1000)            
                __delay_ms(100);                
                break;                
                
            default:break;                
                
        }
    }
}


void Rev(void) {
    
    AIN1 = AIN2 = BIN1 = BIN2 = 0;          // U~(100us)   
    __delay_us(100);
    AIN2 = BIN2 = 1;                        // (500ms) 
    __delay_ms(500);
    AIN1 = AIN2 = BIN1 = BIN2 = 0;          // ~(100us)   
    __delay_us(100);

}


/**
 End of File
*/